Bug 473311 - Segmentation fault in ipmitool always -- 0: cmpb $0x0,(%rax) /* is byte NUL? */
Segmentation fault in ipmitool always -- 0: cmpb $0x0,(%rax) /* is byte NUL? */
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: ipmitool (Show other bugs)
11
All Linux
medium Severity urgent
: ---
: ---
Assigned To: Jan Safranek
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-27 11:35 EST by Robert Scheck
Modified: 2010-03-12 10:29 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-01-14 03:30:34 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
output.pcap.bz2 (4.93 KB, application/x-bzip)
2009-12-23 11:26 EST, Robert Scheck
no flags Details

  None (edit)
Description Robert Scheck 2008-11-27 11:35:49 EST
Description of problem:
Following happens ALWAYS for me in Fedora 10, OpenIPMI from Fedora 8 works.

[root@rsc ~]# ipmitool -I lan -H 172.16.42.213 -U admin -P admin -a sensor list
Password: 
CPU Temp.        | 53.000     | degrees C  | ok    | 0.000     | 18.000    | 20.000    | 65.000    | 80.000    | 90.000    
Env Temp 1       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 2       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 3       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 4       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 5       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 6       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 7       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 8       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Speicherzugriffsfehler (core dumped)
[root@rsc ~]# 

[root@rsc ~]# gdb ipmitool core.19910 
GNU gdb Fedora (6.8-29.fc10)
Copyright (C) 2008 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-redhat-linux-gnu"...

warning: Can't read pathname for load map: Input/output error.
Reading symbols from /lib64/libm-2.9.so...Reading symbols from /usr/lib/debug/lib64/libm-2.9.so.debug...done.
done.
Loaded symbols for /lib64/libm-2.9.so
Reading symbols from /lib64/libreadline.so.5.2...Reading symbols from /usr/lib/debug/lib64/libreadline.so.5.2.debug...done.
done.
Loaded symbols for /lib64/libreadline.so.5.2
Reading symbols from /lib64/libncurses.so.5.6...Reading symbols from /usr/lib/debug/lib64/libncurses.so.5.6.debug...done.
done.
Loaded symbols for /lib64/libncurses.so.5.6
Reading symbols from /lib64/libtinfo.so.5.6...Reading symbols from /usr/lib/debug/lib64/libtinfo.so.5.6.debug...done.
done.
Loaded symbols for /lib64/libtinfo.so.5.6
Reading symbols from /lib64/libcrypto.so.0.9.8g...Reading symbols from /usr/lib/debug/lib64/libcrypto.so.0.9.8g.debug...done.
done.
Loaded symbols for /lib64/libcrypto.so.0.9.8g
Reading symbols from /lib64/libc-2.9.so...Reading symbols from /usr/lib/debug/lib64/libc-2.9.so.debug...done.
done.
Loaded symbols for /lib64/libc-2.9.so
Reading symbols from /lib64/libdl-2.9.so...Reading symbols from /usr/lib/debug/lib64/libdl-2.9.so.debug...done.
done.
Loaded symbols for /lib64/libdl-2.9.so
Reading symbols from /lib64/libz.so.1.2.3...Reading symbols from /usr/lib/debug/lib64/libz.so.1.2.3.debug...done.
done.
Loaded symbols for /lib64/libz.so.1.2.3
Reading symbols from /lib64/ld-2.9.so...Reading symbols from /usr/lib/debug/lib64/ld-2.9.so.debug...done.
done.
Loaded symbols for /lib64/ld-2.9.so
Core was generated by `ipmitool -I lan -H 172.16.42.213 -U admin -P XXXXX -a sensor list'.
Program terminated with signal 11, Segmentation fault.
[New process 19910]
#0  strlen () at ../sysdeps/x86_64/strlen.S:37
37	0:	cmpb $0x0,(%rax)	/* is byte NUL? */
(gdb) bt full
#0  strlen () at ../sysdeps/x86_64/strlen.S:37
No locals.
#1  0x00000037448495ee in _IO_vfprintf_internal (s=0x7fffba506dd0, format=<value optimized out>, ap=0x7fffba506f30) at vfprintf.c:1581
	len = <value optimized out>
	string_malloced = 32767
	alt = 0
	is_long = 0
	prec = -1
	is_negative = 4588082
	base = 12
	string = 0x3 <Address 0x3 out of bounds>
	space = 0
	width = 0
	showsign = 0
	group = 0
	is_char = 0
	pad = 32 ' '
	the_arg = {pa_wchar = 0, pa_int = 0, pa_long_int = 0, pa_long_long_int = 0, pa_u_int = 0, pa_u_long_int = 0, pa_u_long_long_int = 0, pa_double = 0, pa_long_double = 0, pa_string = 0x0, pa_wstring = 0x0, pa_pointer = 0x0}
	left = 0
	is_long_double = 0
	is_short = 0
	use_outdigits = 0
	spec = 115 's'
	_buffer = {__routine = 0, __arg = 0x0, __canceltype = 0, __prev = 0x0}
	_avail = 0
	thousands_sep = 0x0
	grouping = 0xffffffffffffffff <Address 0xffffffffffffffff out of bounds>
	done = 0
	f = (const unsigned char *) 0x45be47 "s"
	lead_str_end = <value optimized out>
	work_buffer = "��������+\002F", '\0' <repeats 13 times>, "�mP��\177", '\0' <repeats 34 times>, "��\001W\000\000\000\000\000\000\000\000\001", '\0' <repeats 35 times>, " ", '\0' <repeats 15 times>, " \020Bf\000\000\000\000\002\000\000\000\000\000\000\000\000�Ns\000\000\000\000m�@D7", '\0' <repeats 27 times>, "F�@D7\000\000\000�oP��\177\000\0000�@D7\000\000\000�oP��\177\000\000�oP��\177\000\000�oP��\177\000\000�\nbD7\000\000\000�oP��\177\000\0002\002F\000\000\000\000\000 pP��\177\000\000�mP��\177\000\000\000�"...
	workstart = 0x0
	workend = 0x7fffba506c98 ""
	ap_save = {{gp_offset = 24, fp_offset = 48, overflow_arg_area = 0x7fffba507010, reg_save_area = 0x7fffba506f50}}
	nspecs_done = 0
	save_errno = 0
	readonly_format = 0
	jump_table = {1, 0, 0, 4, 0, 14, 0, 6, 0, 0, 7, 2, 0, 3, 9, 0, 5, 8, 8, 8, 8, 8, 8, 8, 8, 8, 0, 0, 0, 0, 0, 0, 0, 26, 0, 25, 0, 19, 19, 19, 0, 29, 0, 0, 12, 0, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 18, 0, 13, 0, 0, 0, 0, 0, 0, 26, 0, 
  20, 15, 19, 19, 19, 10, 15, 28, 0, 11, 24, 23, 17, 22, 12, 0, 21, 27, 16, 0, 0, 18, 0, 13}
	__PRETTY_FUNCTION__ = "_IO_vfprintf_internal"
	step0_jumps = {0, -2590, -1536, -931, -1440, -1344, -2496, -2292, -1985, -1751, -1027, -1124, 333, 3797, 2126, 2176, 3782, 3846, 1109, 1645, -828, -44, 3244, -585, -506, -4434, 2956, 3510, 3616, -2388}
	step1_jumps = {0, 0, 0, 0, 0, 0, 0, 0, 0, -1751, -1027, -1124, 333, 3797, 2126, 2176, 3782, 3846, 1109, 1645, -828, -44, 3244, -585, -506, -4434, 2956, 3510, 3616, 0}
	step2_jumps = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1027, -1124, 333, 3797, 2126, 2176, 3782, 3846, 1109, 1645, -828, -44, 3244, -585, -506, -4434, 2956, 3510, 3616, 0}
	step3a_jumps = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1230, 0, 0, 0, 2126, 2176, 3782, 3846, 1109, 0, 0, 0, 0, -585, 0, 0, 0, 0, 0, 0}
	step3b_jumps = {0 <repeats 11 times>, 333, 0, 0, 2126, 2176, 3782, 3846, 1109, 1645, -828, -44, 3244, -585, -506, -4434, 2956, 0, 0, 0}
	step4_jumps = {0 <repeats 14 times>, 2126, 2176, 3782, 3846, 1109, 1645, -828, -44, 3244, -585, -506, -4434, 2956, 0, 0, 0}
	step4_jumps = {2756 <repeats 14 times>, 3347, 3397, 1996, 2114, 3699, 3714, -2858, 2267, 437, 1003, 3658, -3945, -4713, 2756, 2756, 2756}
#2  0x000000374487158a in _IO_vsnprintf (string=0x7fffba507050 "", maxlen=<value optimized out>, format=0x45be46 "%s", args=0x7fffba506f30) at vsnprintf.c:120
	sf = {f = {_sbf = {_f = {_flags = -72515583, _IO_read_ptr = 0x7fffba507050 "", _IO_read_end = 0x7fffba507050 "", _IO_read_base = 0x7fffba507050 "", _IO_write_base = 0x7fffba507050 "", _IO_write_ptr = 0x7fffba507050 "", 
        _IO_write_end = 0x7fffba50705f "", _IO_buf_base = 0x7fffba507050 "", _IO_buf_end = 0x7fffba50705f "", _IO_save_base = 0x0, _IO_backup_base = 0x0, _IO_save_end = 0x0, _markers = 0x0, _chain = 0x0, _fileno = 7402304, _flags2 = 0, 
        _old_offset = 7402304, _cur_column = 0, _vtable_offset = 104 'h', _shortbuf = "", _lock = 0x0, _offset = 217832173004, _codecvt = 0x6e696d6461, _wide_data = 0x2000000000, _freeres_list = 0x0, _freeres_buf = 0x7ff0006, 
        _freeres_size = 36762560, _mode = -1, _unused2 = "\000\000\000\000%\000\000\000\000\000\000\000��0\002\000\000\000"}, _vtable = 0x3744b6b440}, _s = {_allocate_buffer = 0, _free_buffer = 0x230f090}}, 
  overflow_buf = "\200�h\000\000\000\000\000�DD\000\000\000\000\000@oP��\177\000\0000oP��\177\000\000�oP��\177\000\000@�p\000\000\000\000\000 �h\000\000\000\000\000�<D\000\000\000\000"}
	ret = -1169133720
#3  0x000000374484fee3 in __snprintf (s=0x3 <Address 0x3 out of bounds>, maxlen=4570694, format=0x7fffba506f68 "\003") at snprintf.c:35
	arg = {{gp_offset = 32, fp_offset = 48, overflow_arg_area = 0x7fffba507010, reg_save_area = 0x7fffba506f50}}
	done = 3
#4  0x0000000000424a5c in snprintf () at /usr/include/bits/stdio2.h:65
---Type <return> to continue, or q <return> to quit--- 
No locals.
#5  ipmi_sensor_print_full_analog () at ipmi_sensor.c:229
	unitstr = '\0' <repeats 15 times>
	thresh_available = <value optimized out>
	val = 0
	rsp = (struct ipmi_rs *) 0x70f340
	status = 0x0
	id = "Env Humidity 1\000\000"
	validread = 0
#6  ipmi_sensor_print_full (intf=0x68d480, sensor=0x230f280) at ipmi_sensor.c:407
No locals.
#7  0x0000000000425419 in ipmi_sensor_list (intf=0x68d480) at ipmi_sensor.c:523
	rec = (uint8_t *) 0x230f280 " "
	header = (struct sdr_get_rs *) 0x68ddd8
	itr = <value optimized out>
	rc = <value optimized out>
#8  0x000000000043365d in ipmi_main (argc=12, argv=0x7fffba507268, cmdlist=0x67b220, intflist=0x0) at ipmi_main.c:637
	intf = <value optimized out>
	sup = <value optimized out>
	privlvl = 0
	target_addr = 0 '\0'
	target_channel = 0 '\0'
	transit_addr = 0 '\0'
	transit_channel = 0 '\0'
	target_lun = 0 '\0'
	my_addr = 0 '\0'
	lookupbit = <value optimized out>
	authtype = -1
	tmp = <value optimized out>
	hostname = 0x230f030 "172.16.42.213"
	username = 0x230f050 "admin"
	password = 0x230f070 "admin"
	intfname = 0x230f010 "lan"
	progname = 0x7fffba5078bc "ipmitool"
	oemtype = 0x0
	sdrcache = 0x0
	kgkey = 0x0
	seloem = 0x0
	port = 0
	devnum = <value optimized out>
	cipher_suite_id = <value optimized out>
	argflag = <value optimized out>
	i = <value optimized out>
	found = -1169132960
	rc = <value optimized out>
	sol_escape_char = <value optimized out>
#9  0x0000000000404530 in main (argc=3, argv=0x45be46) at ipmitool.c:122
	rc = <value optimized out>
Current language:  auto; currently asm
(gdb) 

Version-Release number of selected component (if applicable):
ipmitool-1.8.10-2.fc10.x86_64

How reproducible:
Always, see above.

Actual results:
Segfaulting ipmitool in Fedora 10

Expected results:
Non-segfaulting ipmitool in Fedora 10 like in Fedora 8

Additional info:
Push needs also to get ASAP into Fedora 10, ipmitool is unusable here.
Comment 1 Robert Scheck 2008-12-01 09:08:50 EST
Ping?
Comment 2 Jan Safranek 2008-12-01 09:26:52 EST
I'm working on it. The 'sensor list' command works on my F10 on x86_64. It's probably hw dependent, I'll try to guess something from the stack trace.
Comment 3 Robert Scheck 2008-12-01 09:31:46 EST
Okay fine. Let me know, if I can support you somehow. As it is reproducible
here with a Raritan Dominion PX (manageable PDU), I can dig out whatever you
maybe need.
Comment 4 Jan Safranek 2008-12-02 07:23:30 EST
Please attach wireshark (or tcpdump) capture of IMAP communication. Use ipmitool with "-C 2" argument to turn off encryption. The password should not be sent in clear text, but check it to be sure or use some dummy one.

If you can, please post also content of *sensor struct at ipmi_sensor_print_full frame when it crashes.

For example (very ugly script):

# start capturing packets, assuming 623 is the IPMI port you use
tcpdump -s 65535 -w output.pcap port 623  &

# run the ipmitool, it MUST crash
ipmitool -I lan -H <host> -U <user> -P <passwd> -C 2 sensor list

# now stop the tcpdump
killall tcpdump

gdb /usr/bin/ipmitool <core>
(gdb) up 5
#now you should see that you are in ipmi_sensor_print_full
(gdb) p *sensor
Comment 5 Bug Zapper 2009-11-18 02:51:34 EST
This message is a reminder that Fedora 10 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 10.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '10'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 10's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 10 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2009-12-18 01:59:01 EST
Fedora 10 changed to end-of-life (EOL) status on 2009-12-17. Fedora 10 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.
Comment 7 Robert Scheck 2009-12-23 11:17:39 EST
Version-Release number of selected component (if applicable):
ipmitool-1.8.11-1.fc11.x86_64

[root@rsc ~]# tcpdump -s 65535 -w output.pcap port 623 &
[1] 27039
[root@rsc ~]# tcpdump: listening on eth0, link-type EN10MB (Ethernet), capture size 65535 bytes

[root@rsc ~]# ipmitool -H 172.16.42.211 -U admin -P Admin123 -C 2 sensor list
CPU Temp.        | 49.000     | degrees C  | ok    | 0.000     | 18.000    | 20.000    | 65.000    | 80.000    | 90.000    
Env Temp 1       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 2       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 3       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 4       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 5       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 6       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 7       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 8       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Speicherzugriffsfehler (Speicherabzug geschrieben)
[root@rsc ~]# killall tcpdump
106 packets captured
107 packets received by filter
0 packets dropped by kernel
[root@rsc ~]# gdb /usr/bin/ipmitool core.27042 
GNU gdb (GDB) Fedora (6.8.50.20090302-39.fc11)
Copyright (C) 2009 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-redhat-linux-gnu".
For bug reporting instructions, please see:
<http://www.gnu.org/software/gdb/bugs/>...

warning: Can't read pathname for load map: Eingabe-/Ausgabefehler.
Reading symbols from /lib64/libm-2.10.2.so...Reading symbols from /usr/lib/debug/lib64/libm-2.10.2.so.debug...done.
done.
Loaded symbols for /lib64/libm-2.10.2.so
Reading symbols from /lib64/libreadline.so.5.2...Reading symbols from /usr/lib/debug/lib64/libreadline.so.5.2.debug...done.
done.
Loaded symbols for /lib64/libreadline.so.5.2
Reading symbols from /lib64/libncurses.so.5.7...Reading symbols from /usr/lib/debug/lib64/libncurses.so.5.7.debug...done.
done.
Loaded symbols for /lib64/libncurses.so.5.7
Reading symbols from /lib64/libtinfo.so.5.7...Reading symbols from /usr/lib/debug/lib64/libtinfo.so.5.7.debug...done.
done.
Loaded symbols for /lib64/libtinfo.so.5.7
Reading symbols from /usr/lib64/libcrypto.so.0.9.8k...Reading symbols from /usr/lib/debug/usr/lib64/libcrypto.so.0.9.8k.debug...done.
done.
Loaded symbols for /usr/lib64/libcrypto.so.0.9.8k
Reading symbols from /lib64/libc-2.10.2.so...Reading symbols from /usr/lib/debug/lib64/libc-2.10.2.so.debug...done.
done.
Loaded symbols for /lib64/libc-2.10.2.so
Reading symbols from /lib64/libdl-2.10.2.so...Reading symbols from /usr/lib/debug/lib64/libdl-2.10.2.so.debug...done.
done.
Loaded symbols for /lib64/libdl-2.10.2.so
Reading symbols from /lib64/libz.so.1.2.3...Reading symbols from /usr/lib/debug/lib64/libz.so.1.2.3.debug...done.
done.
Loaded symbols for /lib64/libz.so.1.2.3
Reading symbols from /lib64/ld-2.10.2.so...Reading symbols from /usr/lib/debug/lib64/ld-2.10.2.so.debug...done.
done.
Loaded symbols for /lib64/ld-2.10.2.so
Core was generated by `ipmitool -H 172.16.42.211 -U admin -P XXXXXXXX -C 2 sensor list'.
Program terminated with signal 11, Segmentation fault.
#0  0x0000003964e487af in _IO_vfprintf_internal (s=0x7fff1ee668b0, format=<value optimized out>, ap=0x7fff1ee66a20) at vfprintf.c:1580
1580		  process_string_arg (((struct printf_spec *) NULL));
(gdb) up 5
#5  ipmi_sensor_print_full (__fmt=<value optimized out>, __n=<value optimized out>, __s=<value optimized out>) at ipmi_sensor.c:477
477			return ipmi_sensor_print_full_analog(intf, sensor);
(gdb) p *sensor
$1 = {keys = {owner_id = 32 ' ', lun = 0 '\0', __reserved = 0 '\0', channel = 0 '\0', sensor_num = 207 '\317'}, entity = {id = 3 '\3', instance = 0 '\0', logical = 0 '\0'}, sensor = {init = {sensor_scan = 1 '\1', event_gen = 1 '\1', 
      type = 0 '\0', hysteresis = 1 '\1', thresholds = 1 '\1', events = 0 '\0', scanning = 0 '\0', __reserved = 0 '\0'}, capabilities = {event_msg = 0 '\0', threshold = 2 '\2', hysteresis = 2 '\2', rearm = 1 '\1', ignore = 0 '\0'}, 
    type = 192 '\300'}, event_type = 1 '\1', mask = {type = {discrete = {assert_event = 31381, deassert_event = 31381, read = 16191}, threshold = {assert_lnc_low = 1, assert_lnc_high = 0, assert_lcr_low = 1, assert_lcr_high = 0, 
        assert_lnr_low = 1, assert_lnr_high = 0, assert_unc_low = 0, assert_unc_high = 1, assert_ucr_low = 0, assert_ucr_high = 1, assert_unr_low = 0, assert_unr_high = 1, status_lnc = 1, status_lcr = 1, status_lnr = 1, reserved = 0, 
        deassert_lnc_low = 1, deassert_lnc_high = 0, deassert_lcr_low = 1, deassert_lcr_high = 0, deassert_lnr_low = 1, deassert_lnr_high = 0, deassert_unc_low = 0, deassert_unc_high = 1, deassert_ucr_low = 0, deassert_ucr_high = 1, 
        deassert_unr_low = 0, deassert_unr_high = 1, status_unc = 1, status_ucr = 1, status_unr = 1, reserved_2 = 0, {set = {readable = 63, lnc = 1, lcr = 1, lnr = 1, unc = 1, ucr = 1, unr = 1, reserved = 0}, read = {lnc = 1, lcr = 1, 
            lnr = 1, unc = 1, ucr = 1, unr = 1, reserved = 0, settable = 63}}}}}, unit = {pct = 0 '\0', modifier = 0 '\0', rate = 0 '\0', analog = 0 '\0', type = {base = 94 '^', modifier = 0 '\0'}}, linearization = 0 '\0', mtol = 1, 
  bacc = 0, analog_flag = {nominal_read = 1 '\1', normal_max = 1 '\1', normal_min = 1 '\1', __reserved = 0 '\0'}, nominal_read = 45 '-', normal_max = 100 'd', normal_min = 0 '\0', sensor_max = 254 '\376', sensor_min = 1 '\1', 
  threshold = {upper = {non_recover = 98 'b', critical = 90 'Z', non_critical = 85 'U'}, lower = {non_recover = 2 '\2', critical = 10 '\n', non_critical = 15 '\17'}, hysteresis = {positive = 1 '\1', negative = 1 '\1'}}, 
  __reserved = "\0", oem = 0 '\0', id_code = 206 '\316', id_string = "Env Humidity 1\0"}
(gdb)
Comment 8 Robert Scheck 2009-12-23 11:26:25 EST
Created attachment 380050 [details]
output.pcap.bz2
Comment 9 Robert Scheck 2009-12-23 11:36:46 EST
Jan, is there anything else you need? I've currently physical access to the
device and I'm able to reproduce whenever needed.
Comment 10 Jan Safranek 2010-01-04 07:40:43 EST
(In reply to comment #9)
> Jan, is there anything else you need? I've currently physical access to the
> device and I'm able to reproduce whenever needed.

I think I got the cause of the error - your IPMI hardware returns SDR record with unknown units. The Sensor Unit Type Code returned from the HW in packet 104 is '0x5e' (=94, available as sensor->unit.type.base), but my IPMI specification describes only codes 0-92 (see IPMI 2.0 spec, Table 43-15).

Therefore the unit_desc array lookup at ipmi_sensor.c:292 gets out of bounds and ipmitool crashes. [ipmitool-1.8.11-1.fc11].

Of course, ipmitool should not crash and report some useful error instead. But also your HW needs to be fixed - it should report only the units listed in the IPMI 2.0 spec (it can use code 0x0 for 'unspecified' units at the last resort).
Comment 11 Jan Safranek 2010-01-04 10:06:04 EST
Please retest with this package(s):
http://kojipkgs.fedoraproject.org/scratch/jsafrane/task_1901013/

I haven't found any Raritan Dominion PX internally :(. If still crashes, I need the same info (see comment #4) + full stack trace ('bt full'). You can find patch inside the srpm. I'll send it upstream if it works.

Thanks in advance!

Jan
Comment 12 Robert Scheck 2010-01-12 10:01:05 EST
The patch works, but it shows "Unknown unit: 94" and "Unknown unit: 95"
where it crashed before. Another IPMI implementation shows instead of
"UNKNOWN" simply "OEM Reserved" and "Session Audit" (see at the end). Are
you really sure, that the IPMI specification you have, is up-to-date?

$ ipmitool -H 172.16.42.210 -U admin -P Admin123 -C 2 sensor list
CPU Temp.        | 50.000     | degrees C  | ok    | 0.000     | 18.000    | 20.000    | 65.000    | 80.000    | 90.000    
Env Temp 1       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 2       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 3       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 4       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 5       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 6       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 7       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Env Temp 8       | na         | degrees C  | na    | -20.000   | 18.000    | 20.000    | 55.000    | 60.000    | 107.500   
Unknown unit: 94
Env Humidity 1   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 2   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 3   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 4   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 5   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 6   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 7   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Unknown unit: 94
Env Humidity 8   | na         | UNKNOWN    | na    | 2.000     | 10.000    | 15.000    | 85.000    | 90.000    | 98.000    
Board 0 Volt     | 231.000    | Volts      | ok    | 76.000    | 79.000    | 81.000    | 250.000   | 250.000   | 255.000   
Board 0 Freq     | 50.000     | Hz         | ok    | na        | na        | na        | na        | na        | na        
Board 1 Volt     | 227.000    | Volts      | ok    | 76.000    | 79.000    | 81.000    | 250.000   | 250.000   | 255.000   
Board 1 Freq     | 50.000     | Hz         | ok    | na        | na        | na        | na        | na        | na        
Board 2 Volt     | 227.000    | Volts      | ok    | 76.000    | 79.000    | 81.000    | 250.000   | 250.000   | 255.000   
Board 2 Freq     | 50.000     | Hz         | ok    | na        | na        | na        | na        | na        | na        
Board 3 Volt     | 224.000    | Volts      | ok    | 76.000    | 79.000    | 81.000    | 250.000   | 250.000   | 255.000   
Board 3 Freq     | 50.000     | Hz         | ok    | na        | na        | na        | na        | na        | na        
Board 4 Volt     | 230.000    | Volts      | ok    | 76.000    | 79.000    | 81.000    | 250.000   | 250.000   | 255.000   
Board 4 Freq     | 50.000     | Hz         | ok    | na        | na        | na        | na        | na        | na        
Unit Volt        | 227.000    | Volts      | ok    | 76.000    | 195.000   | 207.000   | 243.000   | 253.000   | 255.000   
R.01 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.01 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.01 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.01 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.01 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.02 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.02 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.02 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.02 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.02 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.03 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.03 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.03 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.03 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.03 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.04 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.04 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.04 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.04 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.04 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.05 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.05 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.05 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.05 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.05 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.06 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.06 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.06 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.06 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.06 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.07 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.07 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.07 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.07 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.07 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.08 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.08 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.08 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.08 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.08 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.09 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.09 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.09 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.09 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.09 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.10 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.10 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.10 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.10 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.10 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.11 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.11 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.11 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.11 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.11 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.12 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.12 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.12 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.12 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.12 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.13 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.13 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.13 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.13 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.13 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.14 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.14 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.14 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.14 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.14 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.15 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.15 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.15 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.15 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.15 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.16 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.16 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.16 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.16 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.16 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.17 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.17 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.17 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.17 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.17 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.18 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.18 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.18 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.18 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.18 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.19 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.19 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.19 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.19 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.19 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.20 Current     | 0.000      | Amps       | nr    | 0.102     | 1.000     | 2.032     | 6.516     | 7.980     | 65.313    
Unknown unit: 95
R.20 PwrFactor   | 0.000      | UNKNOWN    | ok    | na        | na        | na        | na        | na        | na        
R.20 Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
R.20 Act. Power  | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
R.20 Apt. Power  | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
Unit Current     | 0.000      | Amps       | ok    | na        | na        | na        | 20.893    | 25.586    | 65.313    
Unit Max Curr    | 0.000      | Amps       | ok    | na        | na        | na        | 65.313    | 65.313    | 65.313    
Unit RMS Pwr     | 0.000      | Watts      | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
Unit Aprt. Pwr   | 0.000      | VA         | ok    | na        | na        | na        | 4285.485  | 6683.439  | 8346.415  
Board 0 Curr     | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
Board 1 Curr     | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
Board 2 Curr     | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
Board 3 Curr     | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
Board 4 Curr     | 0.000      | Amps       | ok    | na        | na        | na        | 44.668    | 44.668    | 65.313    
Circuit Break 1  | 0x0        | discrete   | 0x0000| na        | na        | na        | na        | na        | na        
Circuit Break 2  | 0x0        | discrete   | 0x0000| na        | na        | na        | na        | na        | na        
Cbrk 1 Curr      | 0.000      | Amps       | ok    | na        | na        | na        | 10.280    | 12.912    | 65.313    
Cbrk 2 Curr      | 0.000      | Amps       | ok    | na        | na        | na        | 10.280    | 12.912    | 65.313    
Cbrk 1 Curr Max  | 0.000      | Amps       | ok    | na        | na        | na        | 65.313    | 65.313    | 65.313    
Cbrk 2 Curr Max  | 0.000      | Amps       | ok    | na        | na        | na        | 65.313    | 65.313    | 65.313    
Store Sensor     | na         | VA         | na    | na        | na        | na        | 8346.415  | 8346.415  | 8346.415  
$

When looking to another IPMI implementation it looks like this:

# ipmi-sensors -h 172.16.42.210 -u admin -p Admin123
3: CPU Temp. (Temperature): 50.00 C (18.00/80.00): [OK]
4: Env Temp 1 (Temperature): -20.00 C (18.00/60.00): [OK]
5: Env Temp 2 (Temperature): -20.00 C (18.00/60.00): [OK]
6: Env Temp 3 (Temperature): -20.00 C (18.00/60.00): [OK]
7: Env Temp 4 (Temperature): -20.00 C (18.00/60.00): [OK]
8: Env Temp 5 (Temperature): -20.00 C (18.00/60.00): [OK]
9: Env Temp 6 (Temperature): -20.00 C (18.00/60.00): [OK]
10: Env Temp 7 (Temperature): -20.00 C (18.00/60.00): [OK]
11: Env Temp 8 (Temperature): -20.00 C (18.00/60.00): [OK]
12: Env Humidity 1 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
13: Env Humidity 2 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
14: Env Humidity 3 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
15: Env Humidity 4 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
16: Env Humidity 5 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
17: Env Humidity 6 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
18: Env Humidity 7 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
19: Env Humidity 8 (OEM Reserved): 0.00 unspecified (10.00/90.00): [OK]
20: Board 0 Volt (Voltage): 230.00 V (79.00/250.00): [OK]
21: Board 0 Freq (FRU Sensor): 50.00 Hz (NA/NA): [OK]
22: Board 1 Volt (Voltage): 223.00 V (79.00/250.00): [OK]
23: Board 1 Freq (FRU Sensor): 50.00 Hz (NA/NA): [OK]
24: Board 2 Volt (Voltage): 226.00 V (79.00/250.00): [OK]
25: Board 2 Freq (FRU Sensor): 50.00 Hz (NA/NA): [OK]
26: Board 3 Volt (Voltage): 223.00 V (79.00/250.00): [OK]
27: Board 3 Freq (FRU Sensor): 50.00 Hz (NA/NA): [OK]
28: Board 4 Volt (Voltage): 228.00 V (79.00/250.00): [OK]
29: Board 4 Freq (FRU Sensor): 50.00 Hz (NA/NA): [OK]
30: Unit Volt (Voltage): 226.00 V (79.00/250.00): [OK]
31: R.01 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
32: R.01 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
33: R.01 Max Curr (Current): 0.10 A (NA/44.67): [OK]
34: R.01 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
35: R.01 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
36: R.02 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
37: R.02 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
38: R.02 Max Curr (Current): 0.10 A (NA/44.67): [OK]
39: R.02 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
40: R.02 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
41: R.03 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
42: R.03 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
43: R.03 Max Curr (Current): 0.10 A (NA/44.67): [OK]
44: R.03 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
45: R.03 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
46: R.04 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
47: R.04 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
48: R.04 Max Curr (Current): 0.10 A (NA/44.67): [OK]
49: R.04 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
50: R.04 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
51: R.05 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
52: R.05 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
53: R.05 Max Curr (Current): 0.10 A (NA/44.67): [OK]
54: R.05 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
55: R.05 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
56: R.06 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
57: R.06 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
58: R.06 Max Curr (Current): 0.10 A (NA/44.67): [OK]
59: R.06 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
60: R.06 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
61: R.07 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
62: R.07 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
63: R.07 Max Curr (Current): 0.10 A (NA/44.67): [OK]
64: R.07 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
65: R.07 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
66: R.08 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
67: R.08 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
68: R.08 Max Curr (Current): 0.10 A (NA/44.67): [OK]
69: R.08 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
70: R.08 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
71: R.09 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
72: R.09 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
73: R.09 Max Curr (Current): 0.10 A (NA/44.67): [OK]
74: R.09 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
75: R.09 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
76: R.10 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
77: R.10 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
78: R.10 Max Curr (Current): 0.10 A (NA/44.67): [OK]
79: R.10 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
80: R.10 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
81: R.11 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
82: R.11 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
83: R.11 Max Curr (Current): 0.10 A (NA/44.67): [OK]
84: R.11 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
85: R.11 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
86: R.12 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
87: R.12 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
88: R.12 Max Curr (Current): 0.10 A (NA/44.67): [OK]
89: R.12 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
90: R.12 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
91: R.13 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
92: R.13 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
93: R.13 Max Curr (Current): 0.10 A (NA/44.67): [OK]
94: R.13 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
95: R.13 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
96: R.14 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
97: R.14 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
98: R.14 Max Curr (Current): 0.10 A (NA/44.67): [OK]
99: R.14 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
100: R.14 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
101: R.15 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
102: R.15 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
103: R.15 Max Curr (Current): 0.10 A (NA/44.67): [OK]
104: R.15 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
105: R.15 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
106: R.16 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
107: R.16 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
108: R.16 Max Curr (Current): 0.10 A (NA/44.67): [OK]
109: R.16 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
110: R.16 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
111: R.17 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
112: R.17 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
113: R.17 Max Curr (Current): 0.10 A (NA/44.67): [OK]
114: R.17 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
115: R.17 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
116: R.18 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
117: R.18 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
118: R.18 Max Curr (Current): 0.10 A (NA/44.67): [OK]
119: R.18 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
120: R.18 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
121: R.19 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
122: R.19 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
123: R.19 Max Curr (Current): 0.10 A (NA/44.67): [OK]
124: R.19 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
125: R.19 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
126: R.20 Current (Current): 0.10 A (0.97/44.67): [At or Below (<=) Lower Non-Recoverable Threshold]
127: R.20 PwrFactor (Session Audit): 0.00 degrees C (NA/NA): [OK]
128: R.20 Max Curr (Current): 0.10 A (NA/44.67): [OK]
129: R.20 Act. Power (Power Unit): 0.10 W (NA/6683.44): [OK]
130: R.20 Apt. Power (Power Unit): 0.10 VA (NA/6683.44): [OK]
131: Unit Current (Current): 0.10 A (NA/65.31): [OK]
132: Unit Max Curr (Current): 0.10 A (NA/65.31): [OK]
133: Unit RMS Pwr (Power Unit): 0.10 W (NA/6683.44): [OK]
134: Unit Aprt. Pwr (Power Unit): 0.10 VA (NA/6683.44): [OK]
135: Board 0 Curr (Current): 0.10 A (NA/65.31): [OK]
136: Board 1 Curr (Current): 0.10 A (NA/65.31): [OK]
137: Board 2 Curr (Current): 0.10 A (NA/65.31): [OK]
138: Board 3 Curr (Current): 0.10 A (NA/65.31): [OK]
139: Board 4 Curr (Current): 0.10 A (NA/65.31): [OK]
140: Circuit Break 1 (Power Supply): [OK]
141: Circuit Break 2 (Power Supply): [OK]
142: Cbrk 1 Curr (Current): 0.10 A (NA/25.59): [OK]
143: Cbrk 2 Curr (Current): 0.10 A (NA/25.59): [OK]
144: Cbrk 1 Curr Max (Current): 0.10 A (NA/65.31): [OK]
145: Cbrk 2 Curr Max (Current): 0.10 A (NA/65.31): [OK]
146: Store Sensor (Power Unit): 0.10 VA (NA/8346.42): [OK]
#
Comment 13 Jan Safranek 2010-01-14 03:30:34 EST
(In reply to comment #12)
> The patch works, but it shows "Unknown unit: 94" and "Unknown unit: 95"
> where it crashed before. Another IPMI implementation shows instead of
> "UNKNOWN" simply "OEM Reserved" and "Session Audit" (see at the end). Are
> you really sure, that the IPMI specification you have, is up-to-date?

Yes, I have the latest published specification. There might be newer version being standardized and not yet published, but I don't have access to such documents - I am just a package maintainer here.

And regarding 'Session Audit' and 'OEM reserved' - it's not unit name, it's sensor type. If you look at the units of 'Session Audit', it shows 'degrees C', which is IMO bug in the other IPMI implementation, and units of 'OEM reserved' is 'unspecified', which is very close to my UKNOWN :).

I've sent the pathes upstream with cc: to you (I hope you don't mind), we can discuss it upstream, with real IPMI guys.
Comment 14 Jan Safranek 2010-01-14 06:00:01 EST
Patch sent to upstream: http://thread.gmane.org/gmane.comp.hardware.ipmitool.devel/1375
Comment 15 naim_malik 2010-03-12 08:27:27 EST
Raritan created SDRs beyond the IPMI 2.0 spec as extensions for use of IPMI in a PDU for active energy reporting. I am the product manager for the Raritan Dominion PX DPU. Glad you released a patch for ipmitool. Thanks.
Comment 16 Robert Scheck 2010-03-12 10:29:49 EST
Well, why does Raritan actually have SDRs out of the IPMI 2.0 spec which are 
supposed to fail with standard IMPI implementations? The patch only adds a fix
to not break but still mentions, that the given SDRs are unknown units. So as
a Raritan customer, I'm more than really unhappy, that Raritan breaks standard 
IPMI 2.0 specs.

Note You need to log in before you can comment on or make changes to this bug.